local supportedActions = function()
    return {
        GLOBAL.ACTIONS.EXTERMEON_ROTATE
    --, GLOBAL.ACTIONS.CHOP
    }
end

local function AggrFn(fn, values)
    local aggr = fn
    if not (type(aggr) == "function") then
        aggr = function(v) return v == fn end
    end
    for k,v in pairs(values) do
        if aggr(v) then
            return true
        end
    end
    return false
end

local function IsSupportedFn(fn)
    return AggrFn(fn, supportedActions())
end

---------------------------------------------------------------

-- function InitMod()
--     -- Chop hack {
--     local EXTERMEON_BAK_ACTIONS_CHOP_fn = GLOBAL.ACTIONS.CHOP.fn
--     GLOBAL.ACTIONS.CHOP.fn = function(act)
--         if act.target:HasTag("extermeon_RotHack") and act.target.components.workable and act.target.components.workable.action == GLOBAL.ACTIONS.HAMMER then
--             act.target.components.workable.action = GLOBAL.ACTIONS.CHOP
--             local result = EXTERMEON_BAK_ACTIONS_CHOP_fn(act)
--             act.target.components.workable.action = GLOBAL.ACTIONS.HAMMER
--             return result
--         end
--         return EXTERMEON_BAK_ACTIONS_CHOP_fn(act)
--     end
--     -- } Chop hack
-- end

local EXTERMEON_ROTATE = GLOBAL.Action({})
    EXTERMEON_ROTATE.id = "EXTERMEON_ROTATE"
    EXTERMEON_ROTATE.str = "Rotate"
    EXTERMEON_ROTATE.fn = function(act)
        if act.target and act.target:HasTag("extermeon_RotHack") then
            if act.target.components.workable and act.target.components.workable.action == GLOBAL.ACTIONS.HAMMER then
                act.target.components.workable:WorkedBy(act.doer, 1)
                return true
            end
        end
        return false
    end
    
local function extend_pitchfork(inst)
    if not inst.components.tool then
        inst:AddComponent("tool")
    end
    inst.components.tool:SetAction(GLOBAL.ACTIONS.EXTERMEON_ROTATE, 1)

    if not inst.components.finiteuses then
    	inst:AddComponent("finiteuses")
    end
    inst.components.finiteuses:SetConsumption(GLOBAL.ACTIONS.EXTERMEON_ROTATE, 0.1)
end

local function extend_farmplot(inst)
    local function onsave(inst, data)
	    data.extermeon_rot = inst.Transform:GetRotation()
    end
    
    local function onload(inst, data)
        if data and data.extermeon_rot then
            inst.Transform:SetRotation(data.extermeon_rot)
    	end
    end

    local function onhit(inst, worker, workleft)
        if worker.components.inventory then
            local tool = worker.components.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.HANDS)
            if tool then
                if IsSupportedFn(function(v) return tool.components.tool:CanDoAction(v) end) then
                    inst.components.workable:SetWorkLeft(workleft + 1)
                    inst.Transform:SetRotation(inst.Transform:GetRotation() + 45)
                end
            end
        end
    end

    local function isvalid(self, action, right)
        -- if not self.inst.components.workable then return false end
        if IsSupportedFn(function(v) return action == v end) and right then 
            return true
        end
        if action == GLOBAL.ACTIONS.HAMMER and not right then
            return false
        end
        return self.workleft > 0 and action == self.action
    end

    inst:AddTag("extermeon_RotHack")
    if not inst.components.workable then
        inst:AddComponent("workable")
    end
	inst.components.workable:SetOnWorkCallback(onhit)
    inst.components.workable.IsActionValid = isvalid

    inst.OnSave = onsave 
    inst.OnLoad = onload 
end

---------------------------------------------------------------

-- Chop hack AddSimPostInit(InitMod)

AddAction(EXTERMEON_ROTATE)
AddPrefabPostInit("pitchfork", extend_pitchfork)
AddPrefabPostInit("slow_farmplot", extend_farmplot)
AddPrefabPostInit("fast_farmplot", extend_farmplot)

AddPrefabPostInit("wall_stone", extend_farmplot)
AddPrefabPostInit("wall_wood", extend_farmplot)
AddPrefabPostInit("wall_hay", extend_farmplot)
AddPrefabPostInit("wall_ruins", extend_farmplot)

AddStategraphActionHandler("wilson", GLOBAL.ActionHandler(GLOBAL.ACTIONS.EXTERMEON_ROTATE, "dolongaction"))

if GLOBAL.ModManager:GetMod("workshop-207427039") ~= nil then
    LoadPOFile("scripts/languages/ex_russian.po", "ru")
end
